Index: LMDZ5/branches/testing/libf/bibio/cray.F
===================================================================
--- LMDZ5/branches/testing/libf/bibio/cray.F	(revision 1795)
+++ LMDZ5/branches/testing/libf/bibio/cray.F	(revision 1795)
@@ -0,0 +1,42 @@
+!
+! $Header$
+!
+#ifdef CRAY
+      SUBROUTINE riencray
+      END
+#else
+      subroutine scopy(n,sx,incx,sy,incy)
+c
+      IMPLICIT NONE
+c
+      integer n,incx,incy,ix,iy,i
+      real sx((n-1)*incx+1),sy((n-1)*incy+1)
+c
+      iy=1
+      ix=1
+      do 10 i=1,n
+         sy(iy)=sx(ix)
+         ix=ix+incx
+         iy=iy+incy
+10    continue
+c
+      return
+      end
+
+      function ssum(n,sx,incx)
+c
+      IMPLICIT NONE
+c
+      integer n,incx,i,ix
+      real ssum,sx((n-1)*incx+1)
+c
+      ssum=0.
+      ix=1
+      do 10 i=1,n
+         ssum=ssum+sx(ix)
+         ix=ix+incx
+10    continue
+c
+      return
+      end
+#endif
Index: LMDZ5/branches/testing/libf/bibio/ismax.F
===================================================================
--- LMDZ5/branches/testing/libf/bibio/ismax.F	(revision 1795)
+++ LMDZ5/branches/testing/libf/bibio/ismax.F	(revision 1795)
@@ -0,0 +1,24 @@
+!
+! $Header$
+!
+      function ismax(n,sx,incx)
+c
+      IMPLICIT NONE
+c
+      INTEGER n,i,incx,ismax,ix
+      real sx((n-1)*incx+1),sxmax
+c
+      ix=1
+      ismax=1
+      sxmax=sx(1)
+      do 10 i=1,n-1
+       ix=ix+incx
+       if(sx(ix).gt.sxmax) then
+         sxmax=sx(ix)
+         ismax=i+1
+       endif
+10    continue
+c
+      return
+      end
+
Index: LMDZ5/branches/testing/libf/bibio/ismin.F
===================================================================
--- LMDZ5/branches/testing/libf/bibio/ismin.F	(revision 1795)
+++ LMDZ5/branches/testing/libf/bibio/ismin.F	(revision 1795)
@@ -0,0 +1,24 @@
+!
+! $Header$
+!
+      FUNCTION ismin(n,sx,incx)
+c
+      IMPLICIT NONE
+c
+      integer n,i,incx,ismin,ix
+      real sx((n-1)*incx+1),sxmin
+c
+      ix=1
+      ismin=1
+      sxmin=sx(1)
+      DO i=1,n-1
+         ix=ix+incx
+         if(sx(ix).lt.sxmin) then
+             sxmin=sx(ix)
+             ismin=i+1
+         endif
+      ENDDO
+c
+      return
+      end
+C
Index: LMDZ5/branches/testing/libf/dyn3d/ce0l.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/ce0l.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3d/ce0l.F90	(revision 1795)
@@ -20,4 +20,5 @@
   USE comgeomphy
   USE infotrac
+  USE indice_sol_mod
 
 #ifdef CPP_IOIPSL
@@ -36,5 +37,5 @@
 #include "dimensions.h"
 #include "paramet.h"
-#include "indicesol.h"
+!#include "indicesol.h"
 #include "iniprint.h"
 #include "temps.h"
Index: LMDZ5/branches/testing/libf/dyn3d/comconst.h
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/comconst.h	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3d/comconst.h	(revision 1795)
@@ -6,5 +6,5 @@
 
       COMMON/comconsti/im,jm,lllm,imp1,jmp1,lllmm1,lllmp1,lcl,          &
-     &                 iflag_top_bound
+     &                 iflag_top_bound,mode_top_bound
       COMMON/comconstr/dtvr,daysec,                                     &
      & pi,dtphys,dtdiss,rad,r,cpp,kappa,cotot,unsim,g,omeg              &
@@ -30,6 +30,8 @@
       REAL omeg ! (rad/s) rotation rate of the planet
       REAL dissip_factz,dissip_deltaz,dissip_zref
-      INTEGER iflag_top_bound
-      REAL tau_top_bound
+! top_bound sponge:
+      INTEGER iflag_top_bound ! sponge type
+      INTEGER mode_top_bound  ! sponge mode
+      REAL tau_top_bound ! inverse of sponge characteristic time scale (Hz)
       REAL daylen ! length of solar day, in 'standard' day length
       REAL year_day ! Number of standard days in a year
Index: LMDZ5/branches/testing/libf/dyn3d/comvert.h
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/comvert.h	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3d/comvert.h	(revision 1795)
@@ -23,5 +23,6 @@
       real bps    ! hybrid sigma contribution at mid-layers
       real scaleheight ! atmospheric (reference) scale height (km)
-      real pseudoalt ! for planets
+      real pseudoalt ! pseudo-altitude of model levels (km), based on presnivs(),
+                     ! preff and scaleheight
 
       integer disvert_type ! type of vertical discretization:
Index: LMDZ5/branches/testing/libf/dyn3d/conf_gcm.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/conf_gcm.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3d/conf_gcm.F	(revision 1795)
@@ -307,7 +307,21 @@
        CALL getin('dissip_zref',dissip_zref )
 
+! top_bound sponge: only active if ok_strato=.true. and iflag_top_bound!=0
+!                   iflag_top_bound=0 for no sponge
+!                   iflag_top_bound=1 for sponge over 4 topmost layers
+!                   iflag_top_bound=2 for sponge from top to ~1% of top layer pressure
        iflag_top_bound=1
+       CALL getin('iflag_top_bound',iflag_top_bound)
+
+! mode_top_bound : fields towards which sponge relaxation will be done:
+!                  mode_top_bound=0: no relaxation
+!                  mode_top_bound=1: u and v relax towards 0
+!                  mode_top_bound=2: u and v relax towards their zonal mean
+!                  mode_top_bound=3: u,v and pot. temp. relax towards their zonal mean
+       mode_top_bound=3
+       CALL getin('mode_top_bound',mode_top_bound)
+
+! top_bound sponge : inverse of charactericstic relaxation time scale for sponge
        tau_top_bound=1.e-5
-       CALL getin('iflag_top_bound',iflag_top_bound)
        CALL getin('tau_top_bound',tau_top_bound)
 
Index: LMDZ5/branches/testing/libf/dyn3d/gcm.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/gcm.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3d/gcm.F	(revision 1795)
@@ -16,4 +16,9 @@
       USE infotrac
       USE control_mod
+
+#ifdef INCA
+! Only INCA needs these informations (from the Earth's physics)
+      USE indice_sol_mod
+#endif
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -77,5 +82,5 @@
 #ifdef INCA
 ! Only INCA needs these informations (from the Earth's physics)
-#include "indicesol.h"
+!#include "indicesol.h"
 #endif
       INTEGER         longcles
Index: LMDZ5/branches/testing/libf/dyn3d/leapfrog.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/leapfrog.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3d/leapfrog.F	(revision 1795)
@@ -436,8 +436,4 @@
      $               clesphy0, dufi,dvfi,dtetafi,dqfi,dpfi  )
 
-         IF (ok_strato) THEN
-           CALL top_bound( vcov,ucov,teta,masse,dufi,dvfi,dtetafi)
-         ENDIF
-       
 c      ajout des tendances physiques:
 c      ------------------------------
@@ -445,4 +441,9 @@
      $                  ucov, vcov, teta , q   ,ps ,
      $                 dufi, dvfi, dtetafi , dqfi ,dpfi  )
+
+         IF (ok_strato) THEN
+           CALL top_bound( vcov,ucov,teta,masse,dtphys)
+         ENDIF
+       
 c
 c  Diagnostique de conservation de l'énergie : difference
@@ -476,13 +477,14 @@
         ! Sponge layer (if any)
         IF (ok_strato) THEN
-          dufi(:,:)=0.
-          dvfi(:,:)=0.
-          dtetafi(:,:)=0.
-          dqfi(:,:,:)=0.
-          dpfi(:)=0.
-          CALL top_bound(vcov,ucov,teta,masse,dufi,dvfi,dtetafi)
-          CALL addfi( dtvr, leapf, forward   ,
-     $                  ucov, vcov, teta , q   ,ps ,
-     $                 dufi, dvfi, dtetafi , dqfi ,dpfi  )
+!          dufi(:,:)=0.
+!          dvfi(:,:)=0.
+!          dtetafi(:,:)=0.
+!          dqfi(:,:,:)=0.
+!          dpfi(:)=0.
+!          CALL top_bound(vcov,ucov,teta,masse,dufi,dvfi,dtetafi)
+           CALL top_bound( vcov,ucov,teta,masse,dtvr)
+!          CALL addfi( dtvr, leapf, forward   ,
+!     $                  ucov, vcov, teta , q   ,ps ,
+!     $                 dufi, dvfi, dtetafi , dqfi ,dpfi  )
         ENDIF ! of IF (ok_strato) 
       ENDIF ! of IF (iflag_phys.EQ.2)
Index: LMDZ5/branches/testing/libf/dyn3d/temps.h
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/temps.h	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3d/temps.h	(revision 1795)
@@ -13,11 +13,11 @@
 ! INCLUDE 'temps.h'
 
-      COMMON/temps/itaufin, dt, day_ini, day_end, annee_ref, day_ref,   &
-     &             itau_dyn, itau_phy, jD_ref, jH_ref, calend,          &
-     &             start_time
+      COMMON/temps/ dt, jD_ref, jH_ref, start_time,                     &
+     &             day_ini, day_end, annee_ref, day_ref,                &
+     &             itau_dyn, itau_phy, itaufin, calend
 
 
       INTEGER   itaufin
-      INTEGER itau_dyn, itau_phy
+      INTEGER itau_dyn, itau_phy 
       INTEGER day_ini, day_end, annee_ref, day_ref
       REAL      dt, jD_ref, jH_ref, start_time
Index: LMDZ5/branches/testing/libf/dyn3d/top_bound.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/top_bound.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3d/top_bound.F	(revision 1795)
@@ -1,3 +1,6 @@
-      SUBROUTINE top_bound( vcov,ucov,teta,masse, du,dv,dh )
+!
+! $Id$
+!
+      SUBROUTINE top_bound(vcov,ucov,teta,masse,dt)
       IMPLICIT NONE
 c
@@ -24,17 +27,39 @@
 c
 c=======================================================================
-c-----------------------------------------------------------------------
-c   Declarations:
-c   -------------
 
-! #include "comgeom.h"
+! top_bound sponge layer model:
+! Quenching is modeled as: A(t)=Am+A0*exp(-lambda*t)
+! where Am is the zonal average of the field (or zero), and lambda the inverse
+! of the characteristic quenching/relaxation time scale
+! Thus, assuming Am to be time-independent, field at time t+dt is given by:
+! A(t+dt)=A(t)-(A(t)-Am)*(1-exp(-lambda*t))
+! Moreover lambda can be a function of model level (see below), and relaxation
+! can be toward the average zonal field or just zero (see below).
+
+! NB: top_bound sponge is only called from leapfrog if ok_strato=.true.
+
+! sponge parameters: (loaded/set in conf_gcm.F ; stored in comconst.h)
+!    iflag_top_bound=0 for no sponge
+!    iflag_top_bound=1 for sponge over 4 topmost layers
+!    iflag_top_bound=2 for sponge from top to ~1% of top layer pressure
+!    mode_top_bound=0: no relaxation
+!    mode_top_bound=1: u and v relax towards 0
+!    mode_top_bound=2: u and v relax towards their zonal mean
+!    mode_top_bound=3: u,v and pot. temp. relax towards their zonal mean
+!    tau_top_bound : inverse of charactericstic relaxation time scale at
+!                       the topmost layer (Hz)
+
+
 #include "comdissipn.h"
+#include "iniprint.h"
 
 c   Arguments:
 c   ----------
 
-      REAL ucov(iip1,jjp1,llm),vcov(iip1,jjm,llm),teta(iip1,jjp1,llm)
-      REAL masse(iip1,jjp1,llm)
-      REAL dv(iip1,jjm,llm),du(iip1,jjp1,llm),dh(iip1,jjp1,llm)
+      real,intent(inout) :: ucov(iip1,jjp1,llm) ! covariant zonal wind
+      real,intent(inout) :: vcov(iip1,jjm,llm) ! covariant meridional wind
+      real,intent(inout) :: teta(iip1,jjp1,llm) ! potential temperature
+      real,intent(in) :: masse(iip1,jjp1,llm) ! mass of atmosphere 
+      real,intent(in) :: dt ! time step (s) of sponge model
 
 c   Local:
@@ -44,16 +69,11 @@
       REAL uzon(jjp1,llm),vzon(jjm,llm),tzon(jjp1,llm)
       
-      INTEGER NDAMP
-      PARAMETER (NDAMP=4)
       integer i
-      REAL,SAVE :: rdamp(llm)
-!     &   (/(0., i =1,llm-NDAMP),0.125E-5,.25E-5,.5E-5,1.E-5/) 
+      REAL,SAVE :: rdamp(llm) ! quenching coefficient
+      real,save :: lambda(llm) ! inverse or quenching time scale (Hz)
 
       LOGICAL,SAVE :: first=.true.
 
       INTEGER j,l
-
-
-C  CALCUL DES CHAMPS EN MOYENNE ZONALE:
       
       if (iflag_top_bound.eq.0) return
@@ -61,30 +81,45 @@
       if (first) then
          if (iflag_top_bound.eq.1) then
-! couche eponge dans les 4 dernieres couches du modele
-             rdamp(:)=0.
-             rdamp(llm)=tau_top_bound
-             rdamp(llm-1)=tau_top_bound/2.
-             rdamp(llm-2)=tau_top_bound/4.
-             rdamp(llm-3)=tau_top_bound/8.
+! sponge quenching over the topmost 4 atmospheric layers
+             lambda(:)=0.
+             lambda(llm)=tau_top_bound
+             lambda(llm-1)=tau_top_bound/2.
+             lambda(llm-2)=tau_top_bound/4.
+             lambda(llm-3)=tau_top_bound/8.
          else if (iflag_top_bound.eq.2) then
-! couce eponge dans toutes les couches de pression plus faible que
-! 100 fois la pression de la derniere couche
-             rdamp(:)=tau_top_bound
+! sponge quenching over topmost layers down to pressures which are
+! higher than 100 times the topmost layer pressure
+             lambda(:)=tau_top_bound
      s       *max(presnivs(llm)/presnivs(:)-0.01,0.)
          endif
+
+! quenching coefficient rdamp(:)
+!         rdamp(:)=dt*lambda(:) ! Explicit Euler approx.
+         rdamp(:)=1.-exp(-lambda(:)*dt)
+
+         write(lunout,*)'TOP_BOUND mode',mode_top_bound
+         write(lunout,*)'Sponge layer coefficients'
+         write(lunout,*)'p (Pa)  z(km)  tau(s)   1./tau (Hz)'
+         do l=1,llm
+           if (rdamp(l).ne.0.) then
+             write(lunout,'(6(1pe12.4,1x))')
+     &        presnivs(l),log(preff/presnivs(l))*scaleheight,
+     &           1./lambda(l),lambda(l)
+           endif
+         enddo
          first=.false.
-         print*,'TOP_BOUND rdamp=',rdamp
-      endif
+      endif ! of if (first)
 
       CALL massbar(masse,massebx,masseby)
 
-      do l=1,llm
+      ! compute zonal average of vcov and u
+      if (mode_top_bound.ge.2) then
+       do l=1,llm
         do j=1,jjm
           vzon(j,l)=0.
           zm=0.
           do i=1,iim
-! Rm: on peut travailler directement avec la moyenne zonale de vcov
-! plutot qu'avec celle de v car le coefficient cv qui relie les deux
-! ne varie qu'en latitude
+! NB: we can work using vcov zonal mean rather than v since the
+! cv coefficient (which relates the two) only varies with latitudes 
             vzon(j,l)=vzon(j,l)+vcov(i,j,l)*masseby(i,j,l)
             zm=zm+masseby(i,j,l)
@@ -92,16 +127,8 @@
           vzon(j,l)=vzon(j,l)/zm
         enddo
-      enddo
+       enddo
 
-      do l=1,llm
-        do i=1,iip1
-          do j=1,jjm
-            dv(i,j,l)=dv(i,j,l)-rdamp(l)*(vcov(i,j,l)-vzon(j,l))
-          enddo
-        enddo
-      enddo
-
-      do l=1,llm
-        do j=2,jjm
+       do l=1,llm
+        do j=2,jjm ! excluding poles
           uzon(j,l)=0.
           zm=0.
@@ -112,8 +139,14 @@
           uzon(j,l)=uzon(j,l)/zm
         enddo
-      enddo
+       enddo
+      else ! ucov and vcov will relax towards 0
+        vzon(:,:)=0.
+        uzon(:,:)=0.
+      endif ! of if (mode_top_bound.ge.2)
 
-      do l=1,llm
-        do j=2,jjm
+      ! compute zonal average of potential temperature, if necessary
+      if (mode_top_bound.ge.3) then
+       do l=1,llm
+        do j=2,jjm ! excluding poles
           zm=0.
           tzon(j,l)=0.
@@ -124,19 +157,40 @@
           tzon(j,l)=tzon(j,l)/zm
         enddo
-      enddo
+       enddo
+      endif ! of if (mode_top_bound.ge.3)
 
-C   AMORTISSEMENTS LINEAIRES:
-
-      do l=1,llm
+      if (mode_top_bound.ge.1) then
+       ! Apply sponge quenching on vcov:
+       do l=1,llm
         do i=1,iip1
-          do j=2,jjm
-            du(i,j,l)=du(i,j,l)
-     s               -rdamp(l)*(ucov(i,j,l)-cu(i,j)*uzon(j,l))
-            dh(i,j,l)=dh(i,j,l)-rdamp(l)*(teta(i,j,l)-tzon(j,l))
+          do j=1,jjm
+            vcov(i,j,l)=vcov(i,j,l)
+     &                  -rdamp(l)*(vcov(i,j,l)-vzon(j,l))
           enddo
         enddo
-      enddo
-      
+       enddo
 
-      RETURN
+       ! Apply sponge quenching on ucov:
+       do l=1,llm
+        do i=1,iip1
+          do j=2,jjm ! excluding poles
+            ucov(i,j,l)=ucov(i,j,l)
+     &                  -rdamp(l)*(ucov(i,j,l)-cu(i,j)*uzon(j,l))
+          enddo
+        enddo
+       enddo
+      endif ! of if (mode_top_bound.ge.1)
+
+      if (mode_top_bound.ge.3) then
+       ! Apply sponge quenching on teta:
+       do l=1,llm
+        do i=1,iip1
+          do j=2,jjm ! excluding poles
+            teta(i,j,l)=teta(i,j,l)
+     &                  -rdamp(l)*(teta(i,j,l)-tzon(j,l))
+          enddo
+        enddo
+       enddo
+      endif ! of if (mode_top_bound.ge.3)
+    
       END
Index: LMDZ5/branches/testing/libf/dyn3dmem/abort_gcm.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/abort_gcm.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dmem/abort_gcm.F	(revision 1795)
@@ -1,4 +1,4 @@
 !
-! $Id$
+! $Id: abort_gcm.F 1747 2013-04-23 14:06:30Z lguez $
 !
 c
@@ -24,5 +24,5 @@
 
       character(len=*) modname
-      integer ierr
+      integer ierr, ierror_mpi
       character(len=*) message
 
@@ -47,5 +47,11 @@
       else
         write(lunout,*) 'Houston, we have a problem ', ierr
+#ifdef CPP_MPI
+C$OMP CRITICAL (MPI_ABORT_GCM)
+        call MPI_ABORT(COMM_LMDZ, 1, ierror_mpi)
+C$OMP END CRITICAL (MPI_ABORT_GCM)
+#else
         stop 1
+#endif          
       endif
       END
Index: LMDZ5/branches/testing/libf/dyn3dmem/calfis_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/calfis_loc.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dmem/calfis_loc.F	(revision 1795)
@@ -34,8 +34,8 @@
       USE dimphy
       USE mod_phys_lmdz_para, mpi_root_xx=>mpi_root 
-      USE parallel, ONLY : omp_chunk, using_mpi,jjb_u,jje_u,jjb_v,jje_v
       USE mod_interface_dyn_phys
       USE IOPHY
 #endif
+      USE parallel, ONLY : omp_chunk, using_mpi,jjb_u,jje_u,jjb_v,jje_v
       USE Write_Field
       Use Write_field_p
@@ -116,6 +116,6 @@
 c    -----------
       LOGICAL  lafin
-      REAL heure
-
+!      REAL heure
+      REAL, intent(in):: jD_cur, jH_cur
       REAL pvcov(iip1,jjb_v:jje_v,llm)
       REAL pucov(iip1,jjb_u:jje_u,llm)
@@ -130,4 +130,5 @@
       REAL pdteta(iip1,jjb_u:jje_u,llm)
       REAL pdq(iip1,jjb_u:jje_u,llm,nqtot)
+      REAL flxw(iip1,jjb_u:jje_u,llm)  ! Flux de masse verticale sur la grille dynamique
 c
       REAL pps(iip1,jjb_u:jje_u)
@@ -226,5 +227,4 @@
       REAL PVteta(klon,ntetaSTD)
       
-      REAL flxw(iip1,jjb_u:jje_u,llm)  ! Flux de masse verticale sur la grille dynamique
       
       REAL SSUM
@@ -234,5 +234,4 @@
       SAVE firstcal,debut
 c$OMP THREADPRIVATE(firstcal,debut)
-      REAL, intent(in):: jD_cur, jH_cur
       
       REAL,SAVE,dimension(1:iim,1:llm):: du_send,du_recv,dv_send,dv_recv
Index: LMDZ5/branches/testing/libf/dyn3dmem/call_calfis_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/call_calfis_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dmem/call_calfis_mod.F90	(revision 1795)
@@ -321,8 +321,4 @@
 #endif
 
-    IF (ok_strato) THEN
-      CALL top_bound_loc( vcov,ucov,teta,masse,dufi,dvfi,dtetafi)
-    ENDIF
-
 #ifdef DEBUG_IO           
     CALL WriteField_u('ucovfi',ucov)
@@ -348,4 +344,9 @@
     ENDDO
 #endif
+
+    IF (ok_strato) THEN
+!      CALL top_bound_loc( vcov,ucov,teta,masse,dufi,dvfi,dtetafi)
+      CALL top_bound_loc(vcov,ucov,teta,masse,dtphys)
+    ENDIF
 
   !$OMP BARRIER
Index: LMDZ5/branches/testing/libf/dyn3dmem/ce0l.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/ce0l.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dmem/ce0l.F90	(revision 1795)
@@ -23,4 +23,5 @@
   USE infotrac
   USE parallel, ONLY: finalize_parallel
+  USE indice_sol_mod
 
 #ifdef CPP_IOIPSL
@@ -39,5 +40,5 @@
 #include "dimensions.h"
 #include "paramet.h"
-#include "indicesol.h"
+!#include "indicesol.h"
 #include "iniprint.h"
 #include "temps.h"
Index: LMDZ5/branches/testing/libf/dyn3dmem/comconst.h
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/comconst.h	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dmem/comconst.h	(revision 1795)
@@ -1,4 +1,4 @@
 !
-! $Id$
+! $Id: comconst.h 1671 2012-10-24 07:10:10Z emillour $
 !
 !-----------------------------------------------------------------------
@@ -6,5 +6,5 @@
 
       COMMON/comconsti/im,jm,lllm,imp1,jmp1,lllmm1,lllmp1,lcl,          &
-     &                 iflag_top_bound
+     &                 iflag_top_bound,mode_top_bound
       COMMON/comconstr/dtvr,daysec,                                     &
      & pi,dtphys,dtdiss,rad,r,cpp,kappa,cotot,unsim,g,omeg              &
@@ -21,6 +21,6 @@
       REAL dtdiss ! (s) time step for the dissipation
       REAL rad ! (m) radius of the planet
-      REAL r ! Reduced Gas constant r=R/mu 
-             ! with R=8.31.. J.K-1.mol-1, mu: mol mass of atmosphere (kg/mol) 
+      REAL r ! Reduced Gas constant r=R/mu
+             ! with R=8.31.. J.K-1.mol-1, mu: mol mass of atmosphere (kg/mol)
       REAL cpp   ! Specific heat Cp (J.kg-1.K-1)
       REAL kappa ! kappa=R/Cp 
@@ -30,6 +30,8 @@
       REAL omeg ! (rad/s) rotation rate of the planet
       REAL dissip_factz,dissip_deltaz,dissip_zref
-      INTEGER iflag_top_bound
-      REAL tau_top_bound
+! top_bound sponge:
+      INTEGER iflag_top_bound ! sponge type
+      INTEGER mode_top_bound  ! sponge mode
+      REAL tau_top_bound ! inverse of sponge characteristic time scale (Hz)
       REAL daylen ! length of solar day, in 'standard' day length
       REAL year_day ! Number of standard days in a year
Index: LMDZ5/branches/testing/libf/dyn3dmem/comvert.h
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/comvert.h	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dmem/comvert.h	(revision 1795)
@@ -1,4 +1,4 @@
 !
-! $Id$
+! $Id: comvert.h 1654 2012-09-24 15:07:18Z aslmd $
 !
 !-----------------------------------------------------------------------
@@ -23,5 +23,6 @@
       real bps    ! hybrid sigma contribution at mid-layers
       real scaleheight ! atmospheric (reference) scale height (km)
-      real pseudoalt ! for planets
+      real pseudoalt ! pseudo-altitude of model levels (km), based on presnivs(),
+                     ! preff and scaleheight
 
       integer disvert_type ! type of vertical discretization:
Index: LMDZ5/branches/testing/libf/dyn3dmem/conf_gcm.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/conf_gcm.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dmem/conf_gcm.F	(revision 1795)
@@ -335,7 +335,21 @@
        CALL getin('dissip_zref',dissip_zref )
 
+! top_bound sponge: only active if ok_strato=.true. and iflag_top_bound!=0
+!                   iflag_top_bound=0 for no sponge
+!                   iflag_top_bound=1 for sponge over 4 topmost layers
+!                   iflag_top_bound=2 for sponge from top to ~1% of top layer pressure
        iflag_top_bound=1
+       CALL getin('iflag_top_bound',iflag_top_bound)
+
+! mode_top_bound : fields towards which sponge relaxation will be done:
+!                  mode_top_bound=0: no relaxation
+!                  mode_top_bound=1: u and v relax towards 0
+!                  mode_top_bound=2: u and v relax towards their zonal mean
+!                  mode_top_bound=3: u,v and pot. temp. relax towards their zonal mean
+       mode_top_bound=3
+       CALL getin('mode_top_bound',mode_top_bound)
+
+! top_bound sponge : inverse of charactericstic relaxation time scale for sponge
        tau_top_bound=1.e-5
-       CALL getin('iflag_top_bound',iflag_top_bound)
        CALL getin('tau_top_bound',tau_top_bound)
 
Index: LMDZ5/branches/testing/libf/dyn3dmem/exner_milieu_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/exner_milieu_loc.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dmem/exner_milieu_loc.F	(revision 1795)
@@ -27,4 +27,5 @@
 c
       USE parallel
+      USE mod_filtreg_p
       IMPLICIT NONE
 c
@@ -120,5 +121,6 @@
         jjb=jj_begin
         jje=jj_end
-        CALL filtreg_p ( pkf,jjb,jje, jmp1, llm, 2, 1, .TRUE., 1 )
+        CALL filtreg_p ( pkf,jjb_u,jje_u,jjb,jje, jmp1, llm,
+     &                 2, 1, .TRUE., 1 )
 
         ! our work is done, exit routine
@@ -206,5 +208,6 @@
       jjb=jj_begin
       jje=jj_end
-      CALL filtreg_p ( pkf,jjb,jje, jmp1, llm, 2, 1, .TRUE., 1 )
+      CALL filtreg_p ( pkf,jjb_u,jje_u,jjb,jje, jmp1, llm,
+     &                 2, 1, .TRUE., 1 )
       
 c    EST-CE UTILE ?? : calcul de beta
Index: LMDZ5/branches/testing/libf/dyn3dmem/gcm.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/gcm.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dmem/gcm.F	(revision 1795)
@@ -19,4 +19,9 @@
       USE filtreg_mod
       USE control_mod
+
+#ifdef INCA
+! Only INCA needs these informations (from the Earth's physics)
+      USE indice_sol_mod
+#endif
 
 #ifdef CPP_PHYS
@@ -75,5 +80,5 @@
 #ifdef INCA
 ! Only INCA needs these informations (from the Earth's physics)
-#include "indicesol.h"
+!#include "indicesol.h"
 #endif
 
@@ -270,5 +275,5 @@
       ! constants & fields, if we run the 'newtonian' or 'SW' cases:
         if (iflag_phys.ne.1) then
-          CALL iniacademic(vcov,ucov,teta,q,masse,ps,phis,time_0)
+          CALL iniacademic_loc(vcov,ucov,teta,q,masse,ps,phis,time_0)
         endif
 
@@ -291,5 +296,5 @@
      .              'GCM: AVANT iniacademic AVANT AVANT AVANT AVANT'
       if (.not.read_start) then
-         CALL iniacademic(vcov,ucov,teta,q,masse,ps,phis,time_0)
+         CALL iniacademic_loc(vcov,ucov,teta,q,masse,ps,phis,time_0)
       endif
 
@@ -398,5 +403,7 @@
 #endif
 
-
+      if (iflag_phys.eq.1) then
+      ! these initialisations have already been done (via iniacademic)
+      ! if running in SW or Newtonian mode
 c-----------------------------------------------------------------------
 c   Initialisation des constantes dynamiques :
@@ -414,4 +421,5 @@
 c   --------------------------
         CALL inifilr
+      endif ! of if (iflag_phys.eq.1)
 c
 c-----------------------------------------------------------------------
